; ATM UNI cell header as seen by an Intel
; processor after swapping the bytes
; using 80486/Pentium BSWAP instruction
;
; remember that bitfields are allocated
; from msb to lsb within a DWORD by assembler
;


    ; GFC       generic flow control
    ; VPI       virtual path indicator
    ; VCI       virtual channel indicator
    ; PTI       payload type identifier
    ; CLP       cell loss priority
    ;
if 0
    AtmHeader record GFC:4, VPI:8, VCI:16, PTI:3, CLP:1
else
    AtmHeader record GFC:4, VPI:8, VCI:16, PTI2:1, PTI1:1, PTI0:1, CLP:1

    ; string aliases for various bits of PTI
    ;
    LAST        equ PTI0                ; last cell in AAL5 PDU
    CE          equ PTI1                ; congestion experienced
    OAM         equ PTI2                ; this is an OAM F5 cell
    E2E         equ PTI0                ; OAM cell is end-to-end, not a segment
    RESERVED    equ PTI1                ; OAM cell is reserved for future use
endif


; this is for using the VC state table
;
VC_SAW_CELL = 1
VC_IS_AAL5  = 2
