;
;
;  Usage :
;      Bit16 lcsum( Bit8 *buffer, Bit16 byte_count )
;
;  Internet compatible 1's complement checksum of data buffer
;
;  (c) 1990 University of Waterloo,
;           Faculty of Engineering,
;           Engineering Microcomputer Network Development Office
;
;  version
;
;    0.1    17 Dec -1990   E. P. Engelke
;
;
        include masmdefs.hsm
        include model.hsm

codedef INCHKSUM
datadef

cstart  INCHKSUM
cpublic inchksum
if      FUNC_L
 	push	DS
        lds     SI, +@AB + 0 [BP]
  	mov     CX, +@AB + 4 [BP]       ; cx = cnt
else
        mov     ESI, +@AB + 0 [EBP]
        movzx   ECX, word ptr +@AB + 4 [EBP]     ; cx = cnt
endif
        mov     BL, CL

if      FUNC_L
        shr     cx, 1
else
        shr     ECX, 1                  ; group into words
endif
        xor     DX, DX                  ; set checksum to 0
        cld

if      FUNC_L
        jcxz    remain
else
        jecxz   remain
endif
        clc
deloop: lodsw
        adc     DX, AX
        loop    deloop

        adc     DX, 0                   ; only two necessary
        adc     DX, 0

remain: and     BL, 1
        jz      done

        xor     AH, AH
        lodsb
        add     DX, AX
        adc     DX, 0
        adc     DX, 0

done:   mov     AX,DX           ; result into ax
        or      AX,AX
if      FUNC_L
        pop     ds
endif
creturn inchksum
cend    INCHKSUM
        end
